#include <windows.h>
#include <memory.h>
#include <string.h>

#include "templatc.h"
#include "resource.h"
#include "c:\excal\exlib.h"
#include "template.h"

extern "C"
	{
	HWND FAR PASCAL ExMDIClient( EXLIBH LibH );
	HWND FAR PASCAL ExCreateTool( EXLIBH LibH, ExcalWindow FAR *control );
	void FAR PASCAL ExSetToDie( EXLIBH LibH );
	void FAR PASCAL ExSetPtr( EXLIBH LibH, LPVOID value );
	LPVOID FAR PASCAL ExGetPtr( EXLIBH LibH );
	void FAR PASCAL ExSetStatus( EXLIBH LibH, LPCSTR text );
	void FAR PASCAL ExAddBlock( EXLIBH LibH, LPVOID data, WORD len );
	}

extern "C"
	{
	BOOL _export PASCAL LibMain( HINSTANCE hInstance, WORD wDataSegment,WORD wHeapSize, LPSTR lpszCmdLine);
	int _export FAR PASCAL WEP(int);
	WORD FAR PASCAL __export PlugInit( EXLIBH libh, LPCSTR args );
	void FAR PASCAL __export PlugDestroy( EXLIBH libh );
	WORD FAR PASCAL __export PlugCommand( EXLIBH libh, LPBYTE cmd, WORD len );
	WORD FAR PASCAL __export PlugProcess( EXLIBH libh );
	}

HINSTANCE _hInst;
const char titlestring[] = "Lux Africae Template";

BOOL _export PASCAL LibMain( HINSTANCE hInstance, WORD wDataSegment,WORD wHeapSize, LPSTR lpszCmdLine)
{
		_hInst = hInstance;
		return TRUE;
}


int _export FAR PASCAL WEP(int whatever)
 {
  return 1;
 }



void FAR PASCAL __export PlugDestroy( EXLIBH LibH )
	{
	#ifdef __DEBUGMSG__
	MessageBox(NULL, "destroying in PlugDestroy", "ok", MB_OK);
	#endif
		    Template __far* theClient = (Template __far*) ExGetPtr(LibH);
		    delete theClient;
    	ExSetPtr(LibH, NULL);
    }


WORD FAR PASCAL __export PlugCommand( EXLIBH LibH, LPBYTE cmd, WORD len )
	{
	    Template __far* theClient = (Template __far*) ExGetPtr(LibH);
	return theClient->server_command(cmd, len);
	}

WORD FAR PASCAL __export PlugProcess( EXLIBH LibH )
	{
    Template __far* theClient = (Template __far*) ExGetPtr(LibH);
	switch(theClient->getstate())
		{
		 case CYCLE:
		    {
		        return AL_IDLE;
		    }
		  case FIN:
		    {
			ExSetToDie(LibH);
			break;
			}
		}
	 return AL_OK;
	}

WORD FAR PASCAL __export PlugInit( EXLIBH LibH, LPCSTR args )
	{
	Template __far * theClient = new Template(LibH, _hInst);
	ExSetPtr(LibH, theClient);
	if(!(theClient->createMDIWindow()))
		MessageBox(NULL, "Could not create client window.", titlestring, MB_OK);
	return AL_OK;
	}
