#include "Templats.h"
#include <stdlib.h>
#include "resource.h"
#include <string.h>

BOOL TemplateS::paint_server(HDC dc, BOOL erase, RECT* rect)

{
   	const int leftalign = 25;
	int toptext = 0;
	BitBlt(dc, 0, 0, rect->right - rect->left, rect->bottom - rect->top, NULL, 0, 0, WHITENESS);
	HDC hdcMemory;
	HBITMAP hbmpMyBitmap, hbmpOld;
	BITMAP bm;
	hbmpMyBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BANNERLOGO));
	if(hbmpMyBitmap == NULL)
		{
		 MessageBox(NULL, "Bitmap was invalid", "Oops", MB_OK);
		}
	GetObject(hbmpMyBitmap, sizeof(BITMAP), &bm);
	hdcMemory = CreateCompatibleDC(dc);
	hbmpOld = SelectObject(hdcMemory, hbmpMyBitmap);
	BitBlt(dc, 0 + leftalign, 0, bm.bmWidth, bm.bmHeight, hdcMemory, 0, 0, SRCCOPY);
	SelectObject(hdcMemory, hbmpOld);
	DeleteDC(hdcMemory);


	toptext = bm.bmHeight + 25;
	char szstring[250] = "Lux Africae Template (ver ";
	strcat(szstring, VERSIONS);
	strcat(szstring, ")");
	TextOut(dc,leftalign, 0 + toptext,  szstring, strlen(szstring));
	strcpy(szstring, __TIMESTAMP__);
	TextOut(dc,leftalign, 20 + toptext,  szstring, strlen(szstring));
	strcpy(szstring, "Written by JeWeL, ");
	TextOut(dc,leftalign, 40 + toptext,  szstring, strlen(szstring));
	strcpy(szstring, "234 Julius Jeppe street, Waterkloof");
	TextOut(dc,leftalign, 60 + toptext,  szstring, strlen(szstring));
	strcpy(szstring, "Pretoria, 0181, Republic of South Africa");
	TextOut(dc,leftalign, 80 + toptext,  szstring, strlen(szstring));
	strcpy(szstring, "e-Mail: jewel@pixie.co.za");
	TextOut(dc,leftalign, 100 + toptext,  szstring, strlen(szstring));
	if(no_nodes)
	    {
        strcpy(szstring, "Licensed to ");
        char serbuf[256];
        AlGetSysSerial(SlotH, serbuf, 15);
        strcat(szstring, serbuf);
        strcat(szstring, " for ");
        _ultoa(no_nodes, serbuf, 10);
        strcat(szstring, serbuf);
        strcat(szstring, " nodes.");
    	TextOut(dc,leftalign, 120 + toptext,  szstring, strlen(szstring));
    	}
    return TRUE;
}

WORD TemplateS::clientcommand(LPBYTE cmd, BYTE len)

{

    return AL_OK;
}

dllinfo __far* TemplateS::getinfo()

{
    return &info;
}

TemplateS::TemplateS(LPSLOT nsloth, HINSTANCE newinst)

{
    no_nodes = 0;
    SlotH = nsloth;
    hInst = newinst;
    memset(&info, 0, sizeof(info));
}
