#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "alchemw.h"
#include <ver.h>
#include "templats.h"

const char titlestring[] = "Lux Africae Template Demo";
HINSTANCE _hinst;

WORD FAR _export PASCAL PlugType( LPSLOT SlotH , LPSTR  title  )
	{
	AlSetState(SlotH, CYCLE);
	AlAlloc(SlotH, sizeof(memswitch));
	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
   	__with (*tswitch)
	    {
            theServer = new TemplateS(SlotH, _hinst);
	    }
	AlUnlock(SlotH);
	AlCaption(SlotH, titlestring);
	strcpy(title, CLIENT_DLL_NAME);
	return AL_WIN_PLUGIN;
	}

WORD _export PASCAL PlugProcess( LPSLOT SlotH )
	{
	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
	WORD state = AlGetState(SlotH);
	WORD returnval = AL_OK;

	return returnval;
	}

void FAR __export PASCAL PlugDestroy( LPSLOT SlotH )
	{
        memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
            __with (*tswitch)
                {
                    delete theServer;
        	    }
    	AlUnlock(SlotH);
	AlFree(SlotH);
	}

BOOL _export PASCAL PlugData( LPSLOT SlotH, BOOL more, void FAR* data )
	{
        return FALSE;
    }

BOOL _export PASCAL
PlugMouse( LPSLOT SlotH, BYTE MouseButton, WORD x, WORD y )
	{
	AlMouseRelease(SlotH);
	return AL_IDLE;
	}

void _export PASCAL PlugActivate (LPSLOT SlotH, BOOL active)
	{
	}

void _export PASCAL PlugPaint( LPSLOT SlotH, HDC dc, BOOL erase, RECT *rect )
	{
     	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
    	    tswitch->theServer->paint_server(dc, erase, rect);
	 	AlUnlock(SlotH);
    }

void _export PASCAL PlugResize( LPSLOT SlotH, WORD width,
WORD height )
	{


	}

BOOL _export PASCAL LibMain( HINSTANCE hInstance, WORD wDataSegment,WORD wHeapSize, LPSTR lpszCmdLine)
{
		_hinst = hInstance;
     	return TRUE;
}

int _export FAR PASCAL WEP(int)
 {
  return 1;
 }

BOOL FAR __export PASCAL PlugUnique( LPSLOT SlotH, LPCSTR args, LPSTR message )
	{
	strcpy(message, "Sorry, you can only run one copy of Lux Africae Template at a time.");
	return TRUE;
	}

WORD _export PASCAL PlugDialog( LPSLOT SlotH, WORD result )
	{
	return AL_IDLE;
}

WORD _export PASCAL PlugButton( LPSLOT SlotH, WORD id )
	{
		AlReleaseButton(SlotH);
	return AL_IDLE;
	}

WORD  FAR	PASCAL	_export PlugCommand(LPSLOT SlotH,LPBYTE cmd,WORD len)
	{
#ifdef __DEBUGLOW__
	    MessageBox(NULL, "Start plugcommand", titlestring, MB_OK);
#endif
	     	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
	     	WORD returnval = CYCLE;
			    returnval = tswitch->theServer->clientcommand(cmd, len);
		 	AlUnlock(SlotH);
	 	return returnval;
//	return AL_OK;
}

DWORD __export FAR PASCAL PlugDLLSize( LPSLOT SlotH )
	{
	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
	dllinfo __far* info = (dllinfo __far*) tswitch->theServer->getinfo();
			HFILE file = _lopen(CLIENT_DLL_NAME, READ);
			if(file != HFILE_ERROR)
				{
				DWORD length = _llseek(file, 0, SEEK_END);
				_lclose(file);
				AlUnlock(SlotH);
				return length;
				}
			else
				{
				AlLogWrite(SlotH, "Client dll file (client dll) not found");
				AlUnlock(SlotH);
				return 0;
				}
	}

WORD _export PASCAL PlugDLLVerify( LPSLOT SlotH, DWORD curOS, VS_FIXEDFILEINFO *info, LPSTR company, LPSTR intern, LPSTR ver, LPSTR descript )
	{
	#ifdef __DEBUG__
	AlLogWrite(SlotH, "Version info:");
	AlLogWrite(SlotH, company);
	AlLogWrite(SlotH, ver);
	AlLogWrite(SlotH, intern);
	AlLogWrite(SlotH, descript);
	#endif
	if((strcmp(ver, "") == 0))
		{
		  _fstrcpy(  company,  "Lux Africae");
          _fstrcpy(  intern,   "Lux Africae Demo Template");
          _fstrcpy(  ver,      VERSIONS);
		  _fstrcpy(  descript, "Lux Africae Client Side Template demo");
		  return NODLL_NONE;
		}
          _fstrcpy(  company,  "Lux Africae");
          _fstrcpy(  intern,   "Lux Africae Demo Template");
          _fstrcpy(  ver,      VERSIONS);
		  _fstrcpy(  descript, "Lux Africae Client Side Template demo");
	double vernum = 0;
	vernum = atof(ver);
	if(vernum < (double) VERSION)
		{
		 _fstrcpy( ver, VERSIONS);
		  return NODLL_MAJOR;
		}
    return  NODLL_OK;
	}

BOOL __export PASCAL PlugNextDLL( LPSLOT SlotH, LPSTR name, WORD limit, LPSTR dest, WORD dlim )
	{
	memswitch __far* tswitch = (memswitch __far*) AlLock(SlotH);
	dllinfo __far* info = (dllinfo __far*) tswitch->theServer->getinfo();

	if(info->clientsent)
	    return FALSE;

	  	_fstrcpy(name, CLIENT_DLL_NAME);
		_fstrcpy(dest, CLIENT_DLL_NAME);
		info->clientsent = TRUE;
		AlUnlock(SlotH);
		return TRUE;
	}
